
import copy
def nm_transf(dist):
    """
            The up-and-down-blocks algorithm
        I. Borg & P. J. F. Groenen(2005). Modern multidimensional scaling, 2nd ed., (p. 206).
        J. B. Kruskal (1964). Nonmetric multidimensional scaling.
                                  Psychometrika, 115-129 (pp. 126-128).
                                            
    """    
    a_dist = copy.copy(dist)
    n = len(a_dist)
    #
    #    Check a_dist[0],...,a_dist[n-1] for monotonicity
    #
    Lpos = 0    #   Start from a_dist[0]
    Rpos = 0
    transf_done = False
    while transf_done == False:
        #
        #    Check a_dist[Lpos],...,a_dist[Rpos] for monotonicity 
        #
        Lok = False
        Rok = False
        #
        #    Check the right value a_dist[Rpos]
        #    If necessary, adjust the values
        #
        if Rpos >= n - 1:
            Rok = True
        elif a_dist[Rpos] <= a_dist[Rpos+1]:
            Rok = True
        else:
            v = a_dist[Rpos] * (Rpos - Lpos + 1) + a_dist[Rpos+1]
            v /= Rpos - Lpos + 2
            Rpos += 1    

            for i in range(Lpos, Rpos+1):
                a_dist[i] = v
        #
        #     Check the left value a_dist[Lpos]
        #     If necessary, adjust the values
        #
        if Lpos <= 0:
            Lok = True
        elif a_dist[Lpos-1] <= a_dist[Lpos]:
            Lok = True
        else:
            v = a_dist[Lpos] * (Rpos - Lpos + 1) + a_dist[Lpos-1]
            v /= (Rpos - Lpos + 2)
            Lpos -= 1
            for i in range(Lpos, Rpos+1):
                a_dist[i] = v

        if Lok and Rok:   #  Monotonicity is satisfied. No adjustment is done
            Rpos += 1
            Lpos = Rpos

        if Rpos > n-1:
            transf_done = True
            
    return a_dist   

